<template>
    <div>
        <main>
            <GameHeader></GameHeader>
            <template v-if="winner">
                <GameWinnerInfo :class="'bs-callout-success'">
                    <p>{{winnerName}} wins</p>
                    <div class="controller__ticTacToe-goBack">
                        <button type="button" class="btn btn-primary" @click="resetCellsValue()">Start new Game!</button>
                    </div>
                </GameWinnerInfo>
            </template>
            <template v-if="(winner === null || winner === '') && moves === 9">
                <GameWinnerInfo :class="'bs-callout-info'">
                    <p>Draw</p>
                    <div class="controller__ticTacToe-goBack">
                        <button type="button" class="btn btn-primary" @click="resetCellsValue()">Start new Game!</button>
                    </div>
                </GameWinnerInfo>
            </template>
            <section class="game">
                <div class="game__ticTacToe">
                    <template v-for="(cell,key) in ticTacToeGame">
                        <div class="game__cell" :key="key" @click="makeMoves(key)" :class="{'game__cell-player2' : cell.value === '0', 'highlighted' : cell.highlight}">
                            {{cell.value}}
                        </div>
                    </template>
                </div>
            </section>
            <section class="controller">
                <div class="controller__ticTacToe">
                    <div class="controller__ticTacToe-goBack">
                        <button type="button" class="btn btn-primary" @click="$router.push('/')">Go Back </button>
                    </div>
                    <div class="controller__ticTacToe-score">
                        <p>{{players.player1.name}} <span class="controller__ticTacToe-score-player1"> {{players.player1.score}} </span></p>
                        <p>{{players.player2.name}}  <span class="controller__ticTacToe-score-player2"> {{players.player2.score}} </span></p>
                    </div>
                    <div class="controller__ticTacToe-reset">
                        <img src="../assets/img/reset.png" class="controller__ticTacToe-reset-img" alt="Reset Game" @click="resetCellsValue()">
                    </div>
                </div>
            </section>
        </main>
    </div>
</template>

<script type="text/ecmascript-6">/* eslint-disable */
import GameHeader from './GameHeader.vue'
import GameWinnerInfo from './GameWinnerInfo.vue';
  export default {
    name: 'Game',
      components: {
          GameHeader,
          GameWinnerInfo
      },
    data() {
      return {
        inProgress: true,
        moves: 0,
        winner: null,
        winnerName: '',
        cells: {
          1: '', 2: '', 3: '',
          4: '', 5: '', 6: '',
          7: '', 8: '', 9: ''
          },
        combinationsToWin: [
          [1, 2, 3],
          [1, 4, 7],
          [1, 5, 9],
          [2, 5, 8],
          [3, 6, 9],
          [3, 5, 7],
          [4, 5, 6],
          [7, 8, 9],
        ],

        players: {
          player1: {
            value: 'X',
            score: 0,
            name: ''
          },
          player2: {
            value: '0',
            score: 0,
            name: ''
          }
        },
        turn: '',
        ticTacToeGame: {
          1: {
              value: null,
              highlight: false,
              index: 1
          },
          2: {
              value: null,
              highlight: false,
              index: 2
          },
          3: {
              value: null,
              highlight: false,
              index: 3
          },
          4: {
              value: null,
              highlight: false,
              index: 4
          },
          5: {
              value: null,
              highlight: false,
              index: 5
          },
          6: {
              value: null,
              highlight: false,
              index: 6
          },
          7: {
              value: null,
              highlight: false,
              index: 7
          },
          8: {
              value: null,
              highlight: false,
              index: 8
          },
          9: {
              value: null,
              highlight: false,
              index: 9
          }
        },
      }
    },
    mounted() {
        //default value
        this.turn = this.players.player1.value;
        if (localStorage.player1Name) {
            this.players.player1.name = localStorage.player1Name;
        }
        if(localStorage.player2Name) {
            this.players.player2.name = localStorage.player2Name;
        }
    },
    methods: {
        //change data when we make a move in our game
      makeMoves(key) {
        const player1Value = this.players.player1.value,
              player2Value = this.players.player2.value;
        if(this.inProgress && !this.ticTacToeGame[key].value) {
          this.ticTacToeGame[key].value = this.turn;
          this.cells[key] = this.ticTacToeGame[key].value;
          this.moves++;
          this.turn =  (this.turn === player1Value) ? player2Value : player1Value;
          this.winningCombinations();
          this.stopGameAndDisplayTheWinner(key);
        }
      },

        // reset the game or start new game
      resetCellsValue() {
        this.moves = 0;
        this.winner = '';
        this.inProgress = true;
        for(let i in this.ticTacToeGame) {
            this.ticTacToeGame[i].value = null;
            this.ticTacToeGame[i].highlight = false
        }
        for(let i in this.cells) {
            this.cells[i] = '';
        }
      },

        //compare the cells with the combinations data and return true when one combination it's trigger
        winningCombinations () {
            for (let i = 0; i < this.combinationsToWin.length; i++) {
                let winningCombination = this.combinationsToWin[i];
                let cells = this.cells;
                if (cells[winningCombination[0]] && cells[winningCombination[0]] === cells[winningCombination[1]] && cells[winningCombination[0]] === cells[winningCombination[2]]) {
                    // set highlight true for winning combination cells
                    for (let i in this.ticTacToeGame) {
                        if(this.ticTacToeGame[i].index === (winningCombination[0])) {
                            this.ticTacToeGame[i].highlight = true;
                        }
                        if(this.ticTacToeGame[i].index === (winningCombination[1])) {
                            this.ticTacToeGame[i].highlight = true;

                        }
                        if(this.ticTacToeGame[i].index === (winningCombination[2])) {
                            this.ticTacToeGame[i].highlight = true;

                        }
                    }
                    return true;
                }
            }
            return false
        },
        // display winner, stop the game and increase score
        stopGameAndDisplayTheWinner(key) {
            if(this.winningCombinations() === true) {
                this.inProgress = false;
                this.winner = this.ticTacToeGame[key].value;
                for(let i in this.players) {
                    if(this.winner === this.players[i].value) {
                        this.players[i].score++;
                        if(this.ticTacToeGame[key].value === this.players[i].value) {
                            this.winnerName = this.players[i].name;
                        }
                    }
                }
            }
        },
    }
  }
</script>

<style scoped lang="scss">
    .game {
        border: 1px solid #fff;
        width: 50rem;
        margin: 5rem auto;
        @media screen and (max-width: 787px) {
            margin: 0;
            width: 100%;
        }
        &__ticTacToe {
            display:flex;
            flex-wrap: wrap;
            height: 50rem;
         }
            .game__cell {
                border: 1px solid #fff;
                font-size: 8rem;
                width: 33.33%;
                height: 33.33%;
                display: flex;
                justify-content: center;
                align-items: center;
                box-sizing: border-box;
                cursor: pointer;
                color: #fff;
                &-player2 {
                    color: #F0E68C;
                }
                &:hover {
                    background-color: #F0E68C;
                    color: #061F3E;

                }
                &:first-of-type {
                    border-left-color: transparent;
                    border-top-color: transparent;
                }
                &.highlighted {
                    background-color: #007bff;
                    transform: scale(1.1);
                    color: #fff;
                }
            }
    }
    .controller {
        width: 50rem;
        margin: 2rem auto;
        @media screen and (max-width: 787px) {
            width: 100%;
        }
        &__ticTacToe {
            display: flex;
            width: 50rem;
            justify-content: center;
            align-items: center;
            flex-wrap: wrap;
            @media screen and (max-width: 787px) {
                width: 100%;
            }
            &-goBack {
                button {
                    background-color: #007bff;
                    color: #fff;
                    font-size: 1.8rem;
                    cursor: pointer;
                    border: 1px solid transparent;
                    padding: .8rem 1.2rem;
                    border-radius: .3rem;
                }
            }
            &-score {
                display: flex;
                font-size: 2rem;
                color: #fff;
                padding-right: 2.5rem;
                padding-left: 2.5rem;
                p {
                    padding-right: 2rem;
                }
                span {
                    padding: .8rem 1.2rem;
                    border: 2px solid #F0E68C;
                }
            }
            &-reset-img {
                height: 5rem;
                cursor: pointer;
            }
        }
    }
</style>
